package vivadaylight3.interlock;

import java.util.ArrayList;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.EnumArmorMaterial;
import net.minecraft.item.EnumToolMaterial;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.common.EnumHelper;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.oredict.OreDictionary;
import vivadaylight3.interlock.blocks.*;
import vivadaylight3.interlock.handlers.*;
import vivadaylight3.interlock.items.components.*;
import vivadaylight3.interlock.items.other.*;
import vivadaylight3.interlock.items.tools.*;
import vivadaylight3.interlock.tileentity.*;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

/**
 * Interlock mod main class
 * @author VivaDaylight3
 * @see https://github.com/VivaDaylight3/interlock
 */

@Mod(modid="Interlock", name="Interlock", version="0.0.1", dependencies = "after:BasicComponents")
@NetworkMod(clientSideRequired=true, serverSideRequired=false, channels = "Interlock", packetHandler = InterlockPacketHandler.class)
public class Interlock{
	
		public String modID = "Interlock";
				
		private static Integer meta;

		public static int blocksTotal;
		public static int[][] blocksCoords;
	
		public static EnumToolMaterial METALLUM = EnumHelper.addToolMaterial("METALLUM", 2, 1561, 7.0F, 6, 10);
		//public static EnumArmorMaterial METALLUMARMOUR = EnumHelper.addArmorMaterial("METALLUMARMOUR", 33, new int[]{2, 6, 5, 2}, 9);
		
		private static final int BLOCK_ID_PREFIX = 506;
		private static final int ITEM_ID_PREFIX = 4032;
		
		private static int oreMetallumID = BLOCK_ID_PREFIX;
		private static int doorBlockID = BLOCK_ID_PREFIX + 1;
		private static int numpadBlockID = BLOCK_ID_PREFIX + 2;
		private static int fenceBlockID = BLOCK_ID_PREFIX + 3;
		private static int energiserBlockID = BLOCK_ID_PREFIX + 4;
		
		private static int ingotMetallumID = ITEM_ID_PREFIX;
		private static int pickaxeMetallumID = ITEM_ID_PREFIX + 1;
		private static int shovelMetallumID = ITEM_ID_PREFIX + 2;
		private static int axeMetallumID = ITEM_ID_PREFIX + 3;
		private static int hoeMetallumID = ITEM_ID_PREFIX + 4;
		private static int swordMetallumID = ITEM_ID_PREFIX + 5;
		private static int keycardID = ITEM_ID_PREFIX + 6;
		private static int circuitComponentID = ITEM_ID_PREFIX + 7;   
		private static int dustMetallumID = ITEM_ID_PREFIX + 8;
		private static int wireComponentID = ITEM_ID_PREFIX + 9;
		private static int axleComponentID = ITEM_ID_PREFIX + 10;
		private static int coilComponentID = ITEM_ID_PREFIX + 11;
		private static int motorComponentID = ITEM_ID_PREFIX + 12;
		private static int doorItemID = ITEM_ID_PREFIX + 13;
		private static int doorComponentID = ITEM_ID_PREFIX + 14;
		private static int plateComponentID = ITEM_ID_PREFIX + 15;
		private static int linkerItemID = ITEM_ID_PREFIX + 16;
		
		private String oreMetallumName = "Metallum Ore";
		private String doorBlockName = "Secure Door Block";
		private String numpadBlockName = "Numpad";
		private String fenceBlockName = "Electric Fence";
		private String energiserBlockName = "Energiser";
		private String ingotMetallumName ="Metallic Ingot";
		private String pickaxeMetallumName = "Metallic Pickaxe";
		private String shovelMetallumName = "Metallic Shovel";
		private String axeMetallumName = "Metallic Axe";
		private String hoeMetallumName = "Metallic Hoe";
		private String swordMetallumName = "Metallic Sword";
		private String keycardName = "Keycard";
		private String circuitComponentName = "Metallic Circuit";
		private String dustMetallumName = "Metallic Dust";
		private String axleComponentName = "Metallic Rod";
		private String coilComponentName = "Magnetic Coil";
		private String motorComponentName = "Torque Motor";
		private String doorItemName = "Secure Door";
		private String doorComponentName = "Secure Door Core";
		private String plateComponentName = "Metallic Plate";
		private String linkerItemName = "Stream Linker";
		
		private ItemStack ingotMetallumIngredient = new ItemStack(Interlock.ingotMetallum);
		private ItemStack redstoneDustIngredient = new ItemStack(Item.redstone);
		private ItemStack dustMetallumIngredient = new ItemStack(Interlock.dustMetallum);
		private ItemStack coilComponentIngredient = new ItemStack(Interlock.coilComponent);
		private ItemStack axleComponentIngredient = new ItemStack(Interlock.axleComponent);
		private ItemStack plateComponentIngredient = new ItemStack(Interlock.plateComponent);
		private ItemStack ingotIronIngredient = new ItemStack(Item.ingotIron);
		private ItemStack circuitComponentIngredient = new ItemStack(Interlock.circuitComponent);
		private ItemStack doorComponentIngredient = new ItemStack(Interlock.doorComponent);
		private ItemStack motorComponentIngredient = new ItemStack(Interlock.motorComponent);
		private ItemStack redstoneComapratorIngredient = new ItemStack(Item.comparator);
						
        @Instance("Interlock")
        public static Interlock instance;
        
        @SidedProxy(clientSide="vivadaylight3.interlock.client.ClientProxy", serverSide="vivadaylight3.interlock.CommonProxy")
        public static CommonProxy proxy;
        
        private InterlockGuiHandler interlockGuiHandler = new InterlockGuiHandler();
        
        public static final ArrayList iDependants = new ArrayList();
                
        @PreInit
        public void preInit(FMLPreInitializationEvent event) {
        	
        	/*
        	Configuration config = new Configuration(event.getSuggestedConfigurationFile());
        	config.load();
        	
        	oreMetallumID = config.get("Block IDs", "Metallic Ore", 506).getInt();
        	doorBlockID = config.get("Block IDs", "Electric Door", 510).getInt();
        	ingotMetallumID = config.get("Item IDs", "Metallic Ingot", 4032).getInt();
        	pickaxeMetallumID = config.get("Tool IDs", "Metallic Pickaxe", 4033).getInt();
        	shovelMetallumID = config.get("Tool IDs", "Metallic Shovel", 4034).getInt();
        	axeMetallumID = config.get("Tool IDs", "Metallic Axe", 4035).getInt();
        	hoeMetallumID = config.get("Tool IDs", "Metallic Hoe", 4036).getInt();
        	swordMetallumID = config.get("Tools IDs", "Metallic Sword", 4037).getInt();
        	helmetMetallumID = config.get("Armour IDs", "Metallic Helmet", 4038).getInt();
        	chestplateMetallumID = config.get("Armour IDs", "Metallic Chestplate", 4039).getInt();
        	leggingsMetallumID = config.get("Armour IDs", "Metallic Leggings", 4040).getInt();
        	bootsMetallumID = config.get("Armour IDs", "Metallic Boots", 4041).getInt();
        	keycardID = config.get("Item IDs", "KeycardItem", 4042).getInt();
        	circuitComponentID = config.get("Item IDs", "Metallic Core", 4043).getInt();
        	dustMetallumID = config.get("Item IDs", "Metallic Dust", 4044).getInt();
        	wireComponentID = config.get("Item IDs", "Metallic Wire", 4045).getInt();
        	chestMetallumID = config.get("Block IDs", "Metallic Chest", 507).getInt();
        	polisherMachineID = config.get("Block IDs", "Polisher", 508).getInt();
        	axleComponentID = config.get("Item IDs", "Machine axle", 4046).getInt();
        	sandpaperComponentID = config.get("Item IDs", "Machine axle", 4046).getInt();
        	polisherComponentID = config.get("Item IDs", "Polisher Core", 4048).getInt();
        	coilComponentID = config.get("Item IDs", "Metallic Coil", 4049).getInt();
        	motorComponentID = config.get("Item IDs", "Traction motor", 4050).getInt();
        	doorItemID = config.get("Item IDs", "Electric Door", 4051).getInt();
        	doorComponentID = config.get("Item IDs", doorComponentName, 4052).getInt();
        	linkerItemID = config.get("Item IDs", linkerItemName, 4053).getInt();
        	
        	config.save();
        	*/
        	
        }
        
        public static CreativeTabs tabInterlock = new CreativeTabs("tabInterlock"){
        
            public ItemStack getIconItemStack() {
                    return new ItemStack(Interlock.ingotMetallum, 1, 0);
            }
		};
        
        public static final Block oreMetallum = new OreMetallum(oreMetallumID, Material.rock);
        public static final Block doorBlock = new DoorBlock(doorBlockID, Material.iron);
        public static final Block numpadBlock = new NumpadBlock(numpadBlockID);
        public static final Block fenceBlock = new FenceBlock(fenceBlockID);
        public static final Block energiserBlock = new EnergiserBlock(energiserBlockID, Material.iron);
        
		public static final Item ingotMetallum = new IngotMetallum(ingotMetallumID);
		public static final Item pickaxeMetallum = new PickaxeMetallum(pickaxeMetallumID, METALLUM);
		public static final Item shovelMetallum = new ShovelMetallum(shovelMetallumID, METALLUM);
		public static final Item axeMetallum = new AxeMetallum(axeMetallumID, METALLUM);
		public static final Item hoeMetallum = new HoeMetallum(hoeMetallumID, METALLUM);
		public static final Item swordMetallum = new SwordMetallum(swordMetallumID, METALLUM);
		public static final Item keycard = new KeycardItem(keycardID);
		public static final Item circuitComponent = new CircuitComponent(circuitComponentID);
		public static final Item dustMetallum = new DustMetallum(dustMetallumID);
		public static final Item axleComponent = new AxleComponent(axleComponentID);
		public static final Item coilComponent = new CoilComponent(coilComponentID);
		public static final Item motorComponent = new MotorComponent(motorComponentID);
		public static final Item doorItem = new DoorItem(doorItemID);
		public static final Item doorComponent = new DoorComponent(doorComponentID);
		public static final Item plateComponent = new PlateComponent(plateComponentID);
		public static final Item linkerItem = new LinkerItem(linkerItemID);

		public static String CHANNEL = "";
        
        static CreativeTabs toolsMod = new CreativeTabs("ToolsMod") {
            public ItemStack getIconItemStack() {
                    return new ItemStack(Interlock.ingotMetallum, 1, 0);
            }
        };
            	                 
        @Init
        public void load(FMLInitializationEvent event) {
        	
                proxy.registerRenderers();
                                
                LanguageRegistry.addName(oreMetallum, oreMetallumName);
                LanguageRegistry.addName(doorBlock, doorBlockName);
                LanguageRegistry.addName(numpadBlock, numpadBlockName);
                LanguageRegistry.addName(fenceBlock, fenceBlockName);
                LanguageRegistry.addName(energiserBlock, energiserBlockName);
                LanguageRegistry.addName(ingotMetallum, ingotMetallumName);
                LanguageRegistry.addName(pickaxeMetallum, pickaxeMetallumName);
                LanguageRegistry.addName(axeMetallum, axeMetallumName);
                LanguageRegistry.addName(shovelMetallum, shovelMetallumName);
                LanguageRegistry.addName(hoeMetallum, hoeMetallumName);
                LanguageRegistry.addName(swordMetallum, swordMetallumName);
                /*
                LanguageRegistry.addName(helmetMetallum, "Metallic Helmet");
                LanguageRegistry.addName(chestplateMetallum, "Metallic Chestplate");
                LanguageRegistry.addName(leggingsMetallum, "Metallic Leggings");
                LanguageRegistry.addName(bootsMetallum, "Metallic Boots");
                */
                LanguageRegistry.addName(keycard, keycardName);
                LanguageRegistry.addName(circuitComponent, circuitComponentName);
                LanguageRegistry.addName(dustMetallum, dustMetallumName);
                LanguageRegistry.addName(axleComponent, axleComponentName);
                LanguageRegistry.addName(coilComponent, coilComponentName);
                LanguageRegistry.addName(motorComponent, motorComponentName);
                LanguageRegistry.addName(doorItem, doorItemName);
                LanguageRegistry.addName(doorComponent, doorComponentName);
                LanguageRegistry.addName(plateComponent, plateComponentName);
                LanguageRegistry.addName(linkerItem, linkerItemName);
                
                LanguageRegistry.instance().addStringLocalization("itemGroup.tabInterlock", "en_US", "Interlock");
                                                                
                GameRegistry.addRecipe(new ItemStack(Interlock.pickaxeMetallum, 1), "iii", " s ", " s ", 'i', new ItemStack(Interlock.ingotMetallum), 's', new ItemStack(Item.stick));
                GameRegistry.addRecipe(new ItemStack(Interlock.axeMetallum, 1), "ii ", "is ", " s ", 'i', new ItemStack(Interlock.ingotMetallum), 's', new ItemStack(Item.stick));
                GameRegistry.addRecipe(new ItemStack(Interlock.shovelMetallum, 1), " i ", " s ", " s ", 'i', new ItemStack(Interlock.ingotMetallum), 's', new ItemStack(Item.stick));
                GameRegistry.addRecipe(new ItemStack(Interlock.hoeMetallum, 1), "ii ", " s ", " s ", 'i', new ItemStack(Interlock.ingotMetallum), 's', new ItemStack(Item.stick));
                GameRegistry.addRecipe(new ItemStack(Interlock.swordMetallum, 1), " i ", " i ", " s ", 'i', new ItemStack(Interlock.ingotMetallum), 's', new ItemStack(Item.stick));
                /*
                GameRegistry.addRecipe(new ItemStack(Interlock.helmetMetallum, 1), "iii", "i i", 'i', new ItemStack(Interlock.ingotMetallum));
                GameRegistry.addRecipe(new ItemStack(Interlock.chestplateMetallum, 1), "i i", "iii", "iii", 'i', new ItemStack(Interlock.ingotMetallum));
                GameRegistry.addRecipe(new ItemStack(Interlock.leggingsMetallum, 1), "iii", "i i", "i i", 'i', new ItemStack(Interlock.ingotMetallum));
                GameRegistry.addRecipe(new ItemStack(Interlock.bootsMetallum, 1), "i i", "i i", 'i', new ItemStack(Interlock.ingotMetallum));
                */
                GameRegistry.addRecipe(new ItemStack(Interlock.keycard, 1), " r ", "dpd", " r ", 'r', redstoneDustIngredient, 'd', dustMetallumIngredient, 'p', plateComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.circuitComponent, 1), " d ", "rpr", " d ", 'd', dustMetallumIngredient, 'r', redstoneDustIngredient, 'p', plateComponentIngredient);
                GameRegistry.addShapelessRecipe(new ItemStack(Interlock.axleComponent, 2), ingotMetallumIngredient, ingotMetallumIngredient);
                GameRegistry.addShapelessRecipe(new ItemStack(Interlock.coilComponent, 2), redstoneDustIngredient, axleComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.motorComponent, 1), "cpc", "pip", "cpc", 'c', coilComponentIngredient, 'p', plateComponentIngredient, 'i', ingotIronIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.numpadBlock, 1), "ib", "cb", "ib", 'i', ingotMetallumIngredient, 'b', new ItemStack(Block.stoneButton), 'c', circuitComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.doorItem, 1), "ii", "cd", "ii", 'i', ingotMetallumIngredient, 'c', circuitComponentIngredient, 'd', doorComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.doorComponent, 1), "m", "a", "m", 'm', motorComponentIngredient, 'a', axleComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.plateComponent, 4), "mm", "mm", 'm', ingotMetallumIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.linkerItem, 1), "r", "c", "a", 'r', redstoneComapratorIngredient, 'c', circuitComponentIngredient, 'a', axleComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.fenceBlock, 12), "aca", "aca", "aca", 'a', axleComponentIngredient, 'c', coilComponentIngredient);
                GameRegistry.addRecipe(new ItemStack(Interlock.energiserBlock, 1), "pkp", "kck", "pkp", 'p', plateComponentIngredient, 'k', coilComponentIngredient, 'c', circuitComponentIngredient);
                
                GameRegistry.registerBlock(oreMetallum, oreMetallumName);
                GameRegistry.registerBlock(doorBlock, doorBlockName);
                GameRegistry.registerBlock(numpadBlock, numpadBlockName);
                GameRegistry.registerBlock(fenceBlock, fenceBlockName);
                GameRegistry.registerBlock(energiserBlock, energiserBlockName);
                
                GameRegistry.registerItem(ingotMetallum, ingotMetallumName);
                GameRegistry.registerItem(pickaxeMetallum, pickaxeMetallumName);
                GameRegistry.registerItem(axeMetallum, axeMetallumName);
                GameRegistry.registerItem(shovelMetallum, shovelMetallumName);
                GameRegistry.registerItem(hoeMetallum, hoeMetallumName);
                GameRegistry.registerItem(swordMetallum, swordMetallumName);
                /*
                GameRegistry.registerItem(helmetMetallum, "Metallum Helmet");
                GameRegistry.registerItem(chestplateMetallum, "Metallum Chesplate");
                GameRegistry.registerItem(leggingsMetallum, "Metallum Leggings");
                GameRegistry.registerItem(bootsMetallum, "Metallum Boots");
                */
                GameRegistry.registerItem(keycard, keycardName);
                GameRegistry.registerItem(circuitComponent, circuitComponentName);
                GameRegistry.registerItem(axleComponent, axleComponentName);
                GameRegistry.registerItem(coilComponent, coilComponentName);
                GameRegistry.registerItem(motorComponent, motorComponentName);
                GameRegistry.registerItem(doorItem, doorItemName);
                GameRegistry.registerItem(doorComponent, doorComponentName);
                GameRegistry.registerItem(plateComponent, plateComponentName);
                GameRegistry.registerItem(linkerItem, linkerItemName);
                
                GameRegistry.registerWorldGenerator(new InterlockWorldGen());
                
                GameRegistry.registerTileEntity(TileEntityNumpadBlock.class, "tileEntityNumpadBlock");
                GameRegistry.registerTileEntity(TileEntityEnergiserBlock.class, "tileEntityEnergiserBlock");
                
                NetworkRegistry.instance().registerGuiHandler(this, interlockGuiHandler);
                
                GameRegistry.addSmelting(Interlock.dustMetallum.itemID, ingotMetallumIngredient, 1.0F);
                
                MinecraftForge.setBlockHarvestLevel(oreMetallum, "pickaxe", 2);
                MinecraftForge.setBlockHarvestLevel(doorBlock, "pickaxe", 2);
                MinecraftForge.setBlockHarvestLevel(numpadBlock, "pickaxe", 2);
                MinecraftForge.setBlockHarvestLevel(fenceBlock, "pickaxe", 2);
                MinecraftForge.setBlockHarvestLevel(energiserBlock, "pickaxe", 1);
                                                
                OreDictionary.registerOre("ingotMetallum", new ItemStack(Interlock.ingotMetallum));
                OreDictionary.registerOre("oreMetallum", new ItemStack(Interlock.oreMetallum));
                OreDictionary.registerOre("dustMetallum", new ItemStack(Interlock.dustMetallum));
                
                MinecraftForge.setToolClass(pickaxeMetallum, "pickaxe", 2);
                MinecraftForge.setToolClass(axeMetallum, "axe", 2);
                MinecraftForge.setToolClass(shovelMetallum, "shovel", 2);
                MinecraftForge.setToolClass(hoeMetallum, "hoe", 2);
                
        }
        
        @PostInit
        public void postInit(FMLPostInitializationEvent event) {
        	
        }
        
        public static void register(Object mod, String channel)
    	{
    		iDependants.add(mod);
    		CHANNEL = channel;
    		
    	}
        
        public static Object getFirstDependant()
    	{
    		if (iDependants.size() > 0)
    		{
    			return iDependants.get(0);
    		}

    		return null;
    	}
        
        /**
         * Get blocks with a given block ID in a radius around a set of coordinates
         * @param world
         * @param x
         * @param y
         * @param z
         * @param radius
         * @param blockID
         * @return int[][] blocksCoords
         */
         
         // TODO Find alternate and more reliable way of adding block coords to int array.
        
		public static int[][] getBlocks(World world, int x, int y, int z, int radius, int blockID){
        	
        	int blocksTotal = 0;
        	        	
        	for(int k = 0; k <= radius; k++){
        	
        		int xplus = x+k;
        		int yplus = y+k;
        	
        		int block1 = world.getBlockId(xplus, yplus, z);
        		
        		if(block1 == blockID){
        			
        			int a = k - 1;
        			
        			
        			        			
        			blocksTotal++;
        			blocksCoords[a][0] = xplus;
        			blocksCoords[a][1] = yplus;
        			blocksCoords[a][2] = z;
        			
        			
        		}
        		        		        	
        	}
        	        	
        	int newRadius = radius * -1;
        	
        	for (int k = 0; k >= newRadius; k--){
        		
        		int xminus = x-k;
        		int yminus = y-k;
        	
        		int block2 = world.getBlockId(xminus, yminus,  z);
        		
        		if(block2 == blockID){
        			
        			int b = k;
        			
        			blocksTotal++;
					blocksCoords[b][0] = xminus;
        			blocksCoords[b][1] = yminus;
        			blocksCoords[b][2] = z;
        			
        		}
        		
        	}
        	
        	return blocksCoords;
        	        	
        }
        
	/**
	 * Returns the side name of the block depending on its metadata and side
	 * @author VivaDaylight3
	 * @param side
	 * @param metadata
	 * @param basemeta
	 * @return String 'top', 'bottom', 'main', 'input', 'output' or 'side'
	 */
		
	public static String getBlockSide(int side, int metadata, int basemeta){
		
		int meta1 = basemeta;
		int meta2 = basemeta + 1;
		int meta3 = basemeta + 2;
		int meta4 = basemeta + 3;
		
		if (side == 1){
			
			return "top";
			
		}if (side == 0){
			
			return "bottom";
		
		}else if((metadata == meta1 && side == 2) || (metadata == meta2 && side == 5) || (metadata == meta3 && side == 3) || (metadata == meta4 && side == 4)){
			
			return "main";
			
		}else if((metadata == meta1 && side == 4) || (metadata == meta2 && side == 2) || (metadata == meta3 && side == 5) || (metadata == meta4 && side == 3)){
			
			return "input";
			
		}else if((metadata == meta1 && side == 5) || (metadata == meta2 && side == 3) || (metadata == meta3 && side == 4) || (metadata == meta4 && side == 2)){
			
			return "output";
			
		}else{
		
			return "side";
		
		}
		
	}
	
	/**
	 * Gets the input side depending on metadata
	 * @param int metadata
	 * @param int block's lowest metadata
	 * @return int input side number
	 */
	public static int getBlockInput(int metadata, int basemetadata){
		
		if(metadata == basemetadata){
			
			return 4;
			
		}else if(metadata == basemetadata + 1){
			
			return 2;
			
		}else if(metadata == basemetadata + 2){
			
			return 5;
			
		}else{
			
			return 3;
			
		}
		
	}
	
	/**
	 * Gets the output side depending on metadata
	 * @param int metadata
	 * @param int block's lowest metadata
	 * @return int output side number
	 */
	public static int getBlockOutput(int metadata, int basemetadata){
		
		if(metadata == basemetadata){
			
			return 5;
			
		}else if(metadata == basemetadata + 1){
			
			return 3;
			
		}else if(metadata == basemetadata + 2){
			
			return 4;
			
		}else{
			
			return 2;
			
		}
		
	}
	
}
