package vivadaylight3.interlock.blocks;

import net.minecraft.block.BlockContainer;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import vivadaylight3.interlock.Interlock;
import vivadaylight3.interlock.tileentity.TileEntityNumpadBlock;

/**
 * Numpad class
 * @author VivaDaylight3
 *
 */

public class NumpadBlock extends BlockContainer
{
	private String code;
	
    public NumpadBlock(int par1)
    {
        super(par1, Material.iron);
        setCreativeTab(Interlock.tabInterlock);
    }
    
    public void registerIcons(IconRegister iconRegister){
    	
        blockIcon = iconRegister.registerIcon("Interlock:numpadBlock");
        
    }

    /**
     * Returns a new instance of a block's tile entity class. Called on placing the block.
     */
    public TileEntity createNewTileEntity(World par1World)
    {
        return new TileEntityNumpadBlock();
    }

    /**
     * Called upon block activation (right click on the block.)
     */
    
    public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer par5EntityPlayer, int par6, float par7, float par8, float par9)
    {
    	
    	TileEntity tileEntity = world.getBlockTileEntity(x, y, z);

        if (tileEntity == null || par5EntityPlayer.isSneaking()){
        	
        	return false;
        	        	
        }
                        
        //if(Interlock.isSetMetaCode(world, x, y, z)){

        	//par5EntityPlayer.openGui(Interlock.instance, 2, world, x, y, z);
        
        //}else{
        	
        	par5EntityPlayer.openGui(Interlock.instance, 1, world, x, y, z);
        	
        //}
        
        return true;
        
    }

    /**
     * If this returns true, then comparators facing away from this block will use the value from
     * getComparatorInputOverride instead of the actual redstone signal strength.
     */
    public boolean hasComparatorInputOverride()
    {
        return false;
    }

    /**
     * If hasComparatorInputOverride returns true, the return value from this is used instead of the redstone signal
     * strength when this block inputs to a comparator.
     */
    public int getComparatorInputOverride(World par1World, int par2, int par3, int par4, int par5)
    {
        return 0;
    }

    /**
     * Called when the block is placed in the world.
     */
    public void onBlockPlacedBy(World par1World, int par2, int par3, int par4, EntityLiving par5EntityLiving, ItemStack par6ItemStack)
    {

    }
}
