package vivadaylight3.interlock.gui;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.packet.Packet;
import net.minecraft.network.packet.Packet250CustomPayload;
import net.minecraft.util.StringTranslate;
import net.minecraft.world.World;
import net.minecraft.world.storage.WorldInfo;

import org.lwjgl.input.Keyboard;

import vivadaylight3.interlock.Interlock;
import vivadaylight3.interlock.handlers.Config;
import vivadaylight3.interlock.tileentity.TileEntityNumpadBlock;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * The GUI displayed if a numpad's code isn't set
 * @author samueltebbs
 *
 */

@SideOnly(Side.CLIENT)
public class GuiNumpadBlock extends GuiScreen
{

    /** Combination and set/clear buttons. */
    private final TileEntityNumpadBlock numpadBlock;
    private GuiButton button1;
    private GuiButton button2;
    private GuiButton button3;
    private GuiButton button4;
    private GuiButton button5;
    private GuiButton button6;
    private GuiButton button7;
    private GuiButton button8;
    private GuiButton button9;
    private GuiButton button0;
    private GuiButton buttonClear;
    private GuiButton buttonSet;
        
    private Integer codeNew;
    private String code;
    private int codeSize = 0;
    
    private String worldName;
    private World world;
    private int x;
    private int y;
    private int z;

    public GuiNumpadBlock(TileEntityNumpadBlock par1, World par2World, int par3x, int par4y, int par5z)
    {
    	numpadBlock = par1;
        world = par2World;
        x = par3x;
        y = par4y;
        z = par5z;
        //this.player = par2Player;
      //  this.player.addChatMessage("GuiNUmpad: constructor");
    }

    /**
     * Called from the main game loop to update the screen.
     */
    public void updateScreen()
    {
        //this.enteredCodeField.updateCursorCounter();
       // this.player.addChatMessage("GuiNUmpad: updateScreen");
    }

    /**
     * Adds the buttons (and other controls) to the screen in question.
     */
    public void initGui()
    {
        StringTranslate stringtranslate = StringTranslate.getInstance();
        Keyboard.enableRepeatEvents(true);
        this.buttonList.clear();
        this.buttonList.add(this.button1 = new GuiButton(1, this.width / 3 - 150, 47, "1"));
        this.buttonList.add(this.button2 = new GuiButton(2, this.width / 3 - 150, 70, "2"));
        this.buttonList.add(this.button3 = new GuiButton(3, this.width / 3 - 150, 93, "3"));
        this.buttonList.add(this.button4 = new GuiButton(4, this.width / 3 - 150, 116, "4"));
        this.buttonList.add(this.button5 = new GuiButton(5, this.width / 3 - 150, 139, "5"));
        this.buttonList.add(this.button6 = new GuiButton(6, this.width / 3 - 150, 162, "6"));
        this.buttonList.add(this.button7 = new GuiButton(7, this.width / 3 - 150, 185, "7"));
        this.buttonList.add(this.buttonSet = new GuiButton(10, this.width - 150, 47, "Set code"));
        this.buttonList.add(this.buttonClear = new GuiButton(11, this.width -150, 70, "Cancel"));
    }

    /**
     * Called when the screen is unloaded. Used to disable keyboard repeat events
     */
    public void onGuiClosed()
    {
        Keyboard.enableRepeatEvents(false);
       // this.player.addChatMessage("GuiNUmpad: onGuiClosed");
    }

    /**
     * Fired when a control is clicked. This is the equivalent of ActionListener.actionPerformed(ActionEvent e).
     */
    protected void actionPerformed(GuiButton par1GuiButton)
    {
        	if (par1GuiButton.id == 1)
            {
            	addToCode("1");

            }else if (par1GuiButton.id == 2)
            {
            	addToCode("2");

            }else if (par1GuiButton.id == 3)
            {
            	
            	addToCode("3");

            }else if (par1GuiButton.id == 4)
            {
            	addToCode("4");

            }
            else if (par1GuiButton.id == 5)
            {
            	addToCode("5");

            }
            else if (par1GuiButton.id == 6)
            {
            	addToCode("6");

            }
            else if (par1GuiButton.id == 7)
            {
            	addToCode("7");

            }else if (par1GuiButton.id == 10){
            	
            	if(codeSize == 4){
            		
            		codeNew = Integer.parseInt(code);
	    			code = null;
	            	codeSize = 0;
	            	mc.displayGuiScreen((GuiScreen)null);
            		
            	}else{
            		
            		System.out.println("Code size is not 4");
            		
            	}
            	
            }else if(par1GuiButton.id == 11){
            	
            	code = null;
            	codeSize = 0;
            	this.mc.displayGuiScreen((GuiScreen)null);
            	System.out.println("Size is: "+codeSize);
    			System.out.println("Code is: "+code);
            	
            	
            }
            else if (par1GuiButton.id == 0)
            {
                String s = "IntlckNumComb";
                ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream();
                DataOutputStream dataoutputstream = new DataOutputStream(bytearrayoutputstream);

                try
                {
                    dataoutputstream.writeInt(this.numpadBlock.xCoord);
                    dataoutputstream.writeInt(this.numpadBlock.yCoord);
                    dataoutputstream.writeInt(this.numpadBlock.zCoord);
                    this.mc.getNetHandler().addToSendQueue(new Packet250CustomPayload(s, bytearrayoutputstream.toByteArray()));
                }
                catch (Exception exception)
                {
                    exception.printStackTrace();
                }

                this.mc.displayGuiScreen((GuiScreen)null);
                
            }
        }

    /**
     * Fired when a key is typed. This is the equivalent of KeyListener.keyTyped(KeyEvent e).
     */
    protected void keyTyped(char par1, int par2)
    {
    	//this.player.addChatMessage("GuiNUmpad: keyTyped");
    	/*
        this.enteredCodeField.textboxKeyTyped(par1, par2);
        this.doneBtn.enabled = this.enteredCodeField.getText().trim().length() > 0;
        */

        if (par2 != 28 && par1 != 13)
        {
            if (par2 == 1)
            {
               this.actionPerformed(this.buttonClear);
            }
        }
        else
        {
            this.actionPerformed(this.buttonSet);
        }
    }

    /**
     * Called when the mouse is clicked.
     */
    protected void mouseClicked(int par1, int par2, int par3)
    {
        super.mouseClicked(par1, par2, par3);
       // this.enteredCodeField.mouseClicked(par1, par2, par3);
    }

    /**
     * Draws the screen and all the components in it.
     */
    public void drawScreen(int par1, int par2, float par3)
    {
    	//this.player.addChatMessage("GuiNumpad: drawScreen");
        StringTranslate stringtranslate = StringTranslate.getInstance();
        this.drawDefaultBackground();
        this.drawCenteredString(this.fontRenderer, "Set 4-digit code", this.width / 2, this.height / 4 - 60 + 20, 16777215);
        /*
        this.drawCenteredString(this.fontRenderer, stringtranslate.translateKey("advMode.setCommand"), this.width / 2, this.height / 4 - 60 + 20, 16777215);
        this.drawString(this.fontRenderer, stringtranslate.translateKey("advMode.command"), this.width / 2 - 150, 47, 10526880);
        this.enteredCodeField.drawTextBox();
        */
        super.drawScreen(par1, par2, par3);
    }
    
    public void addToCode(String num){
    	
    	if(codeSize < 4){
    		
    		if (code==null){
    			
    			code = num;
    			codeSize++;
    			System.out.println("Size is: "+codeSize);
    			System.out.println("Code is: "+code);
    			
    		}else{
    		
    			code = code+num;
    			codeSize++;
    			System.out.println("Size is: "+codeSize);
    			System.out.println("Code is: "+code);
    		
    		}
    		
    	}else{
    		
    		System.out.println("Code is already 4 digits long");
    		
    	}
	}
}