package vivadaylight3.interlock.handlers;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * The class that manages config files
 * @author VivaDaylight3
 *
 */

public class Config {
	
	/**
	 * Makes a config file if one doesn't exist already. (Not forge config)
	 * @param path
	 * @param filename
	 */
	
	public static void makeConfig(String path, String filename){
		
		Properties prop = new Properties();
		
		try{
			File file = new File(path+filename);
			
			File dir = new File(path);
			
			if(!dir.exists()){
				
				dir.mkdir();
				
			}
			
			if(file.exists()){
				
			}else{
			
				FileInputStream in = new FileInputStream(path+filename);
				FileOutputStream out = new FileOutputStream(path+filename);
				prop.setProperty("testkey", "testvalue");
				prop.store(out, null);
				in.close();
			
			}
				
			
		}catch(IOException e){
			
			e.printStackTrace();
		}
		
	}
	
	/**
	 * Sets a string key's value
	 * @param par1key
	 * @param par2value
	 * @param par3path
	 * @param par4filename
	 * @throws IOException
	 */
	
	public void setStringKey(String par1key, String par2value, String par3path, String par4filename) throws IOException{
		
		try{
		Properties prop = new Properties();
		FileInputStream in = new FileInputStream(par3path+par4filename);
		FileOutputStream out = new FileOutputStream(par3path+par4filename);
		prop.load(in);
		prop.setProperty(par1key, par2value);
		prop.store(out, null);
		in.close();
		
		}catch(IOException e){
			
			e.printStackTrace();
			
		}
		
	}
	
	/**
	 * Gets a string key's value
	 * @param par1key
	 * @param par2path
	 * @param par3filename
	 * @return
	 * @throws IOException
	 */
	
	public String getStringKey(String par1key, String par2path, String par3filename) throws IOException{
		
		try{
			
		Properties properties = new Properties();
		FileInputStream in = new FileInputStream(par2path+par3filename);
		FileOutputStream out = new FileOutputStream(par2path+par3filename);
		properties.load(new FileInputStream(par2path+par3filename));
		String value = properties.getProperty(par1key);
		properties.store(out, null);
		in.close();
		return value;
		
		}catch(IOException e){
		
		e.printStackTrace();
		return "error";
		
	}
		
	}
	
	/**
	 * Removes a key from the config
	 * @param par1key
	 * @param par2path
	 * @param par3filename
	 * @throws IOException
	 */
	
	public void removeKey(String par1key, String par2path, String par3filename) throws IOException{
		
		FileInputStream in = new FileInputStream(par2path+par3filename);
		FileOutputStream out = new FileOutputStream(par2path+par3filename);
		Properties properties = new Properties();
		properties.remove(par1key);
		properties.store(out, null);
		in.close();
	}

}
