package vivadaylight3.interlock.handlers;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import vivadaylight3.interlock.Interlock;
import vivadaylight3.interlock.container.ContainerEnergiserBlock;
import vivadaylight3.interlock.container.ContainerNumpadBlock;
import vivadaylight3.interlock.gui.GuiEnergiserBlock;
import vivadaylight3.interlock.gui.GuiNumpadBlock;
import vivadaylight3.interlock.gui.GuiNumpadBlockProgrammed;
import vivadaylight3.interlock.tileentity.TileEntityEnergiserBlock;
import vivadaylight3.interlock.tileentity.TileEntityNumpadBlock;
import cpw.mods.fml.common.network.IGuiHandler;

/**
 * Class to handle what GUI to display
 * @author VivaDaylight3
 *
 */

public class InterlockGuiHandler implements IGuiHandler{
	
	String code;
	private World world;
	private String worldName;

	@Override
	public Object getServerGuiElement(int ID, EntityPlayer player, World world,
			int x, int y, int z) {
				
		TileEntity tileEntity = world.getBlockTileEntity(x, y, z);
		
		if(tileEntity instanceof TileEntityNumpadBlock){
						
			return new ContainerNumpadBlock(((TileEntityNumpadBlock) tileEntity));
			
		}else if (tileEntity instanceof TileEntityEnergiserBlock){
			
			return new ContainerEnergiserBlock(player.inventory, ((TileEntityEnergiserBlock) tileEntity));
			
		}
		
		return null;
		
	}

	public Object getClientGuiElement(int ID, EntityPlayer player, World par3world,
			int x, int y, int z) {
				
		TileEntity tileEntity = par3world.getBlockTileEntity(x, y, z);
				
		if(tileEntity instanceof TileEntityNumpadBlock){
			
			if(ID==1){
						
				return new GuiNumpadBlock(((TileEntityNumpadBlock) tileEntity), par3world, x, y, z);
			
			}else if(ID==2){
				
				return new GuiNumpadBlockProgrammed(((TileEntityNumpadBlock) tileEntity), par3world, x, y, z);
				
			}
			
		}else if (tileEntity instanceof TileEntityEnergiserBlock){
			
			return new GuiEnergiserBlock(player.inventory, ((TileEntityEnergiserBlock) tileEntity));
			
		}
		
		return null;
	}
	
	

}
