package vivadaylight3.interlock.handlers;

import java.util.Random;

import vivadaylight3.interlock.Interlock;

import net.minecraft.world.World;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.gen.feature.WorldGenMinable;

import cpw.mods.fml.common.IWorldGenerator;

/**
 * Handles world gen
 * @author VivaDaylight3
 *
 */

public class InterlockWorldGen implements IWorldGenerator{
	
	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkProvider chunkGenerator, IChunkProvider chunkProvider) {
	
		switch(world.provider.dimensionId){
		case -1:
		    generateNether(world, random, chunkX * 16, chunkZ * 16);
		    break;
		case 0:
		    generateSurface(world, random, chunkX * 16, chunkZ * 16);
		    break;
		case 1:
		    generateEnd(world, random, chunkX * 16, chunkZ * 16);
		    break;
		}
		
	}

	private void generateEnd(World world, Random random, int i, int j) {
		
	}

	private void generateSurface(World world, Random random, int i, int j) {
		
		// 10 is the amount of veins in each chunk.
			for(int k = 0; k < 10; k++) {
					
				int metallumOreX = i + random.nextInt(16);
					// 30 is the maximum height at which the ore will generate, 0 - 30.
				int metallumOreY = random.nextInt(30);
				int metallumOreZ = j + random.nextInt(16);
					
				(new WorldGenMinable(Interlock.oreMetallum.blockID, 13)).generate(world, random, metallumOreX, metallumOreY, metallumOreZ);
				    
			}
		
	}

	private void generateNether(World world, Random random, int i, int j) {
		
	}

}
