package vivadaylight3.interlock.items.other;

import vivadaylight3.interlock.Interlock;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Icon;
import net.minecraft.world.World;

/**
 * Ingot item class
 * @author VivaDaylight3
 *
 */

public class IngotMetallum extends Item {

        public IngotMetallum(int id) {
        	
                super(id);
         
             // Item Configuration
                setMaxStackSize(64);
                setCreativeTab(Interlock.tabInterlock);
                setUnlocalizedName("ingotMetallum");
                
        }
        
        // Adds a texture file for the item. Textures are in MCP/src/minecraft/'package'/'modname'/textures/'item or block'
        
        public void registerIcons(IconRegister iconRegister){
        	
                 itemIcon = iconRegister.registerIcon("Interlock:ingotMetallum");
                 
        }
        
        public boolean onItemUse(ItemStack par1ItemStack, EntityPlayer par2EntityPlayer, 
        		World par3World, int par4, int par5, int par6, int par7, float par8, float par9, float par10){
        	
        	//Interlock interlockOb = new Interlock();
        	
        	int[][] blockCoords = Interlock.getBlocks(par3World, par4, par5, par6,  10, Block.grass.blockID);
        	
        	int blockTotal = Interlock.blocksTotal;
        	
        	par2EntityPlayer.addChatMessage("block total is "+blockTotal);
        	
        	if(blockTotal<=1){
        		
        		int radius = blockTotal * -1;
        		
        		for(int k = radius; k<blockTotal; k++){
        			
        			int x = blockCoords[radius][0];
        			int y = blockCoords[radius][1];
        			int z = blockCoords[radius][2];
        			
        			par3World.setBlock(x, y, z, Block.glowStone.blockID, par4, 2);
        			
        		}
        		
        		int radius2 = blockTotal;
        		
        		for(int k = radius2; k<blockTotal; k++){
        			
        			int x = blockCoords[radius2][0];
        			int y = blockCoords[radius2][1];
        			int z = blockCoords[radius2][2];
        			
        			par3World.setBlock(x, y, z, Block.glowStone.blockID, par4, 2);
        			
        		}
        		
        	}
        	
        	return true;
        	
        }

}