package vivadaylight3.interlock.tileentity;

import java.util.HashMap;
import java.util.List;
import java.util.Set;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.common.ForgeDirection;
import universalelectricity.core.block.IConductor;
import universalelectricity.core.block.IConnectionProvider;
import universalelectricity.core.electricity.ElectricityNetworkHelper;
import universalelectricity.core.electricity.ElectricityPack;
import universalelectricity.core.electricity.IElectricityNetwork;
import universalelectricity.prefab.CustomDamageSource;
import universalelectricity.prefab.tile.TileEntityConductor;
import universalelectricity.prefab.tile.TileEntityElectricityRunnable;
import vivadaylight3.interlock.Interlock;
import vivadaylight3.interlock.blocks.EnergiserBlock;

public class TileEntityFenceBlock extends TileEntityElectricityRunnable implements IElectricityNetwork
{
	public boolean isRequesting;
	
	private final double AMPS_PER_SHOCK = 10;
	
	public ElectricityPack getRequest()
	{
		if (this.isRequesting)
		{
			return new ElectricityPack(EnergiserBlock.WATTS_PER_TICK / this.getVoltage(), this.getVoltage());
		}
		else
		{
			return new ElectricityPack();
		}
	}

	@Override
	public boolean canConnect(ForgeDirection direction) {
		
		return true;
		
	}
	
	public void shockEntity(Entity entity){
		
		TileEntityEnergiserBlock energiserBlock = new TileEntityEnergiserBlock();
	
		IElectricityNetwork inputNetwork = ElectricityNetworkHelper.getNetworkFromTileEntity(energiserBlock.outputTile, energiserBlock.outputDirection);
	
		if(inputNetwork != null){
		
			if(inputNetwork.getProduced().amperes > this.AMPS_PER_SHOCK){
			
				if(inputNetwork.isProducing(energiserBlock)){
					
					double voltage = energiserBlock.getVoltage();
				
					this.isRequesting = true;
		
					int damage;
		
					inputNetwork.startRequesting(this, this.AMPS_PER_SHOCK, voltage);
		
					if(voltage <= 120){
			
						damage = 2;
			
					}else{
			
						damage = 4;
			
					}
		
					entity.attackEntityFrom(CustomDamageSource.electrocution, damage);
			
					inputNetwork.stopRequesting(this);
					
					this.isRequesting = false;
		
				}else{
				
					System.out.println("There is no energiser producing in this network");
				
				}
		
			}else{
			
				System.out.println("Not enough amps");
			
			}
		
		}else{
		
			System.out.println("No input network");
		
		}
	}

	@Override
	public void startProducing(TileEntity tileEntity,
			ElectricityPack electricityPack) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void startProducing(TileEntity tileEntity, double amperes,
			double voltage) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean isProducing(TileEntity tileEntity) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void stopProducing(TileEntity tileEntity) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void startRequesting(TileEntity tileEntity,
			ElectricityPack electricityPack) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void startRequesting(TileEntity tileEntity, double amperes,
			double voltage) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean isRequesting(TileEntity tileEntity) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void stopRequesting(TileEntity tileEntity) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public ElectricityPack getProduced(TileEntity... ignoreTiles) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ElectricityPack getRequest(TileEntity... ignoreTiles) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ElectricityPack getRequestWithoutReduction() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ElectricityPack consumeElectricity(TileEntity tileEntity) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public HashMap<TileEntity, ElectricityPack> getProducers() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<TileEntity> getProviders() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public HashMap<TileEntity, ElectricityPack> getConsumers() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<TileEntity> getReceivers() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Set<IConductor> getConductors() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public double getTotalResistance() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public double getLowestCurrentCapacity() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void cleanUpConductors() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void refreshConductors() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mergeConnection(IElectricityNetwork network) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void splitNetwork(IConnectionProvider splitPoint) {
		// TODO Auto-generated method stub
		
	}
}